Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3483)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3484)
@@ -3965,4 +4192,5 @@
        jb = nys
        je = nyn
+       kb = 0
        IF ( nesting_mode /= 'vertical' )  THEN
           IF ( bc_dirichlet_l )  THEN
@@ -3989,4 +4217,14 @@
           ENDIF
        ENDIF
+
+       IF ( var == 'u' )  THEN 
+          var_flag = 1 
+       ELSEIF ( var == 'v' )  THEN
+          var_flag = 2 
+       ELSEIF ( var == 'w' )  THEN
+          var_flag = 3
+       ELSE
+          var_flag = 0
+       ENDIF
 !
 !--    Trilinear interpolation.
@@ -3997,5 +4235,5 @@
 !--          topography top at grid point (j,i) in order to not overwrite 
 !--          the bottom BC.
-             kb = get_topography_top_index_ji( j, i, TRIM ( var ) ) + 1
+!             kb = get_topography_top_index_ji( j, i, TRIM ( var ) ) + 1             
              DO  k = kb, nzt + 1
                 l = ic(i)
@@ -4062,4 +4300,64 @@
 
        ENDIF
+!
+!--    Apply the reversibility correction. 
+       DO  l = icl, icr
+          DO  m = jcs, jcn
+             DO  n = 0, kct+1
+                ijk = 1
+                cellsum   = 0.0_wp
+                cellsumd  = 0.0_wp
+!
+!--             Note that the index name i must not be used here as a loop 
+!--             index name since i is the constant boundary index, hence 
+!--             the name ia. 
+                DO  i = ifl(l), ifu(l)   
+                   DO  j = jfl(m), jfu(m)
+                      DO  k = kfl(n), kfu(n)
+                         cellsum = cellsum + MERGE( f(k,j,i), 0.0_wp,           &
+                              BTEST( wall_flags_0(k,j,i), var_flag ) )
+                         celltmpd(ijk) = ABS( fc(n,m,l) - f(k,j,i) )
+                         cellsumd      = cellsumd  + MERGE( celltmpd(ijk),      &
+                              0.0_wp, BTEST( wall_flags_0(k,j,i), var_flag ) )
+                         ijk = ijk + 1
+                      ENDDO
+                   ENDDO
+                ENDDO
+                
+                IF ( ijkfc(n,m,l) /= 0 )  THEN
+                   cellsum   = cellsum / REAL( ijkfc(n,m,l), KIND=wp )
+                   rcorr     = fc(n,m,l) - cellsum
+                   cellsumd  = cellsumd / REAL( ijkfc(n,m,l), KIND=wp )
+                ELSE
+                   cellsum   = 0.0_wp                  
+                   rcorr     = 0.0_wp
+                   cellsumd  = 1.0_wp
+                   celltmpd  = 1.0_wp
+                ENDIF
+! 
+!--             Distribute the correction term to the child nodes according to 
+!--             their relative difference to the parent value such that the
+!--             node with the largest difference gets the largest share of the 
+!--             correction. The distribution is skipped if rcorr is negligibly 
+!--             small in order to avoid division by zero. 
+                IF ( ABS(rcorr) < 0.000001_wp )  THEN                  
+                   cellsumd  = 1.0_wp
+                   celltmpd  = 1.0_wp
+                ENDIF
+
+                ijk = 1
+                DO  i = ifl(l), ifu(l)
+                   DO  j = jfl(m), jfu(m)
+                      DO  k = kfl(n), kfu(n)
+                         rcorr_ijk = rcorr * celltmpd(ijk) / cellsumd 
+                         f(k,j,i) = f(k,j,i) + rcorr_ijk
+                         ijk = ijk + 1
+                      ENDDO
+                   ENDDO
+                ENDDO
+             
+             ENDDO  ! n
+          ENDDO  ! m
+       ENDDO  ! l
 
     END SUBROUTINE pmci_interp_tril_all
@@ -4165,130 +4463,4 @@
 
 
- SUBROUTINE pmci_ensure_nest_mass_conservation
-
-!
-!-- Adjust the volume-flow rate through the top boundary so that the net volume
-!-- flow through all boundaries of the current nest domain becomes zero.
-    IMPLICIT NONE
-
-    INTEGER(iwp) ::  i                           !<
-    INTEGER(iwp) ::  ierr                        !<
-    INTEGER(iwp) ::  j                           !<
-    INTEGER(iwp) ::  k                           !<
-
-    REAL(wp) ::  dxdy                            !<
-    REAL(wp) ::  innor                           !<
-    REAL(wp) ::  w_lt                            !<
-    REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !<
-
-!
-!-- Sum up the volume flow through the left/right boundaries
-    volume_flow(1)   = 0.0_wp
-    volume_flow_l(1) = 0.0_wp
-
-    IF ( bc_dirichlet_l )  THEN
-       i = 0
-       innor = dy
-       DO   j = nys, nyn
-          DO   k = nzb+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)   &
-                                     * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_0(k,j,i), 1 ) )
-          ENDDO
-       ENDDO
-    ENDIF
-
-    IF ( bc_dirichlet_r )  THEN
-       i = nx + 1
-       innor = -dy
-       DO   j = nys, nyn
-          DO   k = nzb+1, nzt
-             volume_flow_l(1) = volume_flow_l(1) + innor * u(k,j,i) * dzw(k)   &
-                                     * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_0(k,j,i), 1 ) )
-          ENDDO
-       ENDDO
-    ENDIF
-
-#if defined( __parallel )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL,         &
-                        MPI_SUM, comm2d, ierr )
-#else
-    volume_flow(1) = volume_flow_l(1)
-#endif
-    
-!
-!-- Sum up the volume flow through the south/north boundaries
-    volume_flow(2)   = 0.0_wp
-    volume_flow_l(2) = 0.0_wp
-
-    IF ( bc_dirichlet_s )  THEN
-       j = 0
-       innor = dx
-       DO   i = nxl, nxr
-          DO   k = nzb+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)   &
-                                     * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_0(k,j,i), 2 ) )
-          ENDDO
-       ENDDO
-    ENDIF
-
-    IF ( bc_dirichlet_n )  THEN
-       j = ny + 1
-       innor = -dx
-       DO   i = nxl, nxr
-          DO   k = nzb+1, nzt
-             volume_flow_l(2) = volume_flow_l(2) + innor * v(k,j,i) * dzw(k)   &
-                                     * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_0(k,j,i), 2 ) )
-          ENDDO
-       ENDDO
-    ENDIF
-
-#if defined( __parallel )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,         &
-                        MPI_SUM, comm2d, ierr )
-#else
-    volume_flow(2) = volume_flow_l(2)
-#endif
-
-!
-!-- Sum up the volume flow through the top boundary
-    volume_flow(3)   = 0.0_wp
-    volume_flow_l(3) = 0.0_wp
-    dxdy = dx * dy
-    k = nzt
-    DO   i = nxl, nxr
-       DO   j = nys, nyn
-          volume_flow_l(3) = volume_flow_l(3) - w(k,j,i) * dxdy
-       ENDDO
-    ENDDO
-
-#if defined( __parallel )
-    IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,         &
-                        MPI_SUM, comm2d, ierr )
-#else
-    volume_flow(3) = volume_flow_l(3)
-#endif
-
-!
-!-- Correct the top-boundary value of w
-    w_lt = (volume_flow(1) + volume_flow(2) + volume_flow(3)) / area_t
-    DO   i = nxl, nxr
-       DO   j = nys, nyn
-          DO  k = nzt, nzt + 1
-             w(k,j,i) = w(k,j,i) + w_lt
-          ENDDO
-       ENDDO
-    ENDDO
-
- END SUBROUTINE pmci_ensure_nest_mass_conservation
-
-
-
  SUBROUTINE pmci_synchronize
 
@@ -4409,5 +4581,4 @@
     DO  m = 1, SIZE( pmc_parent_for_child ) - 1
        child_id = pmc_parent_for_child(m)
-       
        IF ( direction == parent_to_child )  THEN
           CALL cpu_log( log_point_s(71), 'pmc parent send', 'start' )
@@ -4484,5 +4655,5 @@
 
        IF ( direction == parent_to_child )  THEN
-
+    
           CALL cpu_log( log_point_s(73), 'pmc child recv', 'start' )
           CALL pmc_c_getbuffer( )
@@ -4492,5 +4663,5 @@
           CALL pmci_interpolation
           CALL cpu_log( log_point_s(75), 'pmc interpolation', 'stop' )
-
+     
        ELSE
 !
@@ -4517,4 +4688,6 @@
        IMPLICIT NONE
 
+       INTEGER(iwp) ::  ibgp       !< index running over the nbgp boundary ghost points in i-direction
+       INTEGER(iwp) ::  jbgp       !< index running over the nbgp boundary ghost points in j-direction
        INTEGER(iwp) ::  n          !< running index for number of chemical species
       
@@ -4527,31 +4700,41 @@
 !--       Left border pe:
           IF ( bc_dirichlet_l )  THEN
-             
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
-                                       r1yo, r2yo, r1zo, r2zo,                 &
-                                       logc_u_l, logc_ratio_u_l,               &
-                                       logc_kbounds_u_l,                       &
-                                       nzt_topo_nestbc_l, 'l', 'u' )
-
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
-                                       r1yv, r2yv, r1zo, r2zo,                 &
-                                       logc_v_l, logc_ratio_v_l,               &
-                                       logc_kbounds_v_l,                       &               
-                                       nzt_topo_nestbc_l, 'l', 'v' )
-
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
-                                       r1yo, r2yo, r1zw, r2zw,                 &
-                                       logc_w_l, logc_ratio_w_l,               &
-                                       logc_kbounds_w_l,                       &
-                                       nzt_topo_nestbc_l, 'l', 'w' )
+
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
+                                       r1yo, r2yo, r1zo, r2zo,                  &
+                                       logc_u_l, logc_ratio_u_l,                &
+                                       logc_kbounds_u_l, nzt_topo_nestbc_l,     &
+                                       kcto, iflu, ifuu, jflo, jfuo, kflo,      &
+                                       kfuo, ijkfc_u, 'l', 'u' )
+
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
+                                       r1yv, r2yv, r1zo, r2zo,                  &
+                                       logc_v_l, logc_ratio_v_l,                &
+                                       logc_kbounds_v_l, nzt_topo_nestbc_l,     &
+                                       kcto, iflo, ifuo, jflv, jfuv, kflo,      &
+                                       kfuo, ijkfc_v, 'l', 'v' )
+
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
+                                       r1yo, r2yo, r1zw, r2zw,                  &
+                                       logc_w_l, logc_ratio_w_l,                &
+                                       logc_kbounds_w_l, nzt_topo_nestbc_l,     &
+                                       kctw, iflo, ifuo, jflo, jfuo, kflw,      &
+                                       kfuw, ijkfc_w, 'l', 'w' )
 
              IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo,              &
-                                          logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l,                    &
-                                          nzt_topo_nestbc_l, 'l', 'e' )
+!                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                                          r1yo, r2yo, r1zo, r2zo,              &
+!                                          logc_w_l, logc_ratio_w_l,            &
+!                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
+!                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+!                                          kfuo, ijkfc_s, 'l', 'e' )
+!
+!--             Interpolation of e is replaced by the Neumann condition. 
+                DO ibgp = -nbgp, -1
+                   e(nzb:nzt,nys:nyn,ibgp) = e(nzb:nzt,nys:nyn,0)
+                ENDDO
+
              ENDIF
 
@@ -4560,6 +4743,7 @@
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l,                    &
-                                          nzt_topo_nestbc_l, 'l', 's' )
+                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'l', 's' )
              ENDIF
 
@@ -4568,6 +4752,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l,                    &                
-                                          nzt_topo_nestbc_l, 'l', 's' )
+                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'l', 's' )
              ENDIF
 
@@ -4577,6 +4762,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_l, logc_ratio_w_l,            &
-                                          logc_kbounds_w_l,                    &
-                                          nzt_topo_nestbc_l, 'l', 's' )
+                                          logc_kbounds_w_l, nzt_topo_nestbc_l, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'l', 's' )
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
@@ -4585,5 +4771,7 @@
                                              logc_w_l, logc_ratio_w_l,         &
                                              logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l, 'l', 's' )  
+                                             nzt_topo_nestbc_l,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'l', 's' )  
 
                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
@@ -4591,5 +4779,7 @@
                                              logc_w_l, logc_ratio_w_l,         &
                                              logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l, 'l', 's' )          
+                                             nzt_topo_nestbc_l,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'l', 's' )          
                 ENDIF
 
@@ -4599,11 +4789,15 @@
                                              logc_w_l, logc_ratio_w_l,         &
                                              logc_kbounds_w_l,                 &
-                                             nzt_topo_nestbc_l, 'l', 's' ) 
+                                             nzt_topo_nestbc_l,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'l', 's' ) 
 
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
                                              r2xo, r1yo, r2yo, r1zo, r2zo,     &
                                              logc_w_l, logc_ratio_w_l,         &
-                                             logc_kbounds_w_l,                 &                
-                                             nzt_topo_nestbc_l, 'l', 's' )             
+                                             logc_kbounds_w_l,                 &
+                                             nzt_topo_nestbc_l,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'l', 's' )             
                 ENDIF
 
@@ -4615,5 +4809,7 @@
                                           logc_w_l, logc_ratio_w_l,            &
                                           logc_kbounds_w_l,                    & 
-                                          nzt_topo_nestbc_l, 'l', 's' )
+                                          nzt_topo_nestbc_l,                   &
+                                          kcto, iflo, ifuo, jflo, jfuo,        &
+                                          kflo, kfuo, ijkfc_s, 'l', 's' )
              ENDIF
 
@@ -4626,5 +4822,7 @@
                                              logc_w_l, logc_ratio_w_l,         &
                                              logc_kbounds_w_l,                 & 
-                                             nzt_topo_nestbc_l, 'l', 's' )
+                                             nzt_topo_nestbc_l,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'l', 's' )
                 ENDDO
              ENDIF
@@ -4638,28 +4836,36 @@
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_r, logc_ratio_u_r,               &
-                                       logc_kbounds_u_r,                       &
-                                       nzt_topo_nestbc_r, 'r', 'u' )
+                                       logc_kbounds_u_r, nzt_topo_nestbc_r,    &
+                                       kcto, iflu, ifuu, jflo, jfuo, kflo,     &
+                                       kfuo, ijkfc_u, 'r', 'u' )
 
              CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
                                        r1yv, r2yv, r1zo, r2zo,                 &
                                        logc_v_r, logc_ratio_v_r,               &
-                                       logc_kbounds_v_r,                       &
-                                       nzt_topo_nestbc_r, 'r', 'v' )
+                                       logc_kbounds_v_r, nzt_topo_nestbc_r,    &
+                                       kcto, iflo, ifuo, jflv, jfuv, kflo,     &
+                                       kfuo, ijkfc_v, 'r', 'v' )
 
              CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
                                        r1yo, r2yo, r1zw, r2zw,                 &
                                        logc_w_r, logc_ratio_w_r,               &
-                                       logc_kbounds_w_r,                       &
-                                       nzt_topo_nestbc_r, 'r', 'w' )
+                                       logc_kbounds_w_r, nzt_topo_nestbc_r,    &
+                                       kctw, iflo, ifuo, jflo, jfuo, kflw,     &
+                                       kfuw, ijkfc_w, 'r', 'w' )
 
              IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo,r2yo, r1zo, r2zo,               &
-                                          logc_w_r, logc_ratio_w_r,            &
-                                          logc_kbounds_w_r,                    &
-                                          nzt_topo_nestbc_r, 'r', 'e' )
-
+!                CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                                          r1yo,r2yo, r1zo, r2zo,               &
+!                                          logc_w_r, logc_ratio_w_r,            &
+!                                          logc_kbounds_w_r, nzt_topo_nestbc_r, &
+!                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+!                                          kfuo, ijkfc_s, 'r', 'e' )
+!
+!--             Interpolation of e is replaced by the Neumann condition. 
+                DO ibgp = nx+1, nx+nbgp
+                   e(nzb:nzt,nys:nyn,ibgp) = e(nzb:nzt,nys:nyn,nx)
+                ENDDO
              ENDIF
 
@@ -4668,6 +4874,7 @@
                                           r2xo, r1yo,r2yo, r1zo, r2zo,         &
                                           logc_w_r, logc_ratio_w_r,            &
-                                          logc_kbounds_w_r,                    &
-                                          nzt_topo_nestbc_r, 'r', 's' )
+                                          logc_kbounds_w_r, nzt_topo_nestbc_r, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'r', 's' )
 
              ENDIF
@@ -4677,6 +4884,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_r, logc_ratio_w_r,            &
-                                          logc_kbounds_w_r,                    &
-                                          nzt_topo_nestbc_r, 'r', 's' )
+                                          logc_kbounds_w_r, nzt_topo_nestbc_r, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'r', 's' )
              ENDIF
 
@@ -4685,6 +4893,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_r, logc_ratio_w_r,            &
-                                          logc_kbounds_w_r,                    &
-                                          nzt_topo_nestbc_r, 'r', 's' )
+                                          logc_kbounds_w_r, nzt_topo_nestbc_r, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 'r', 's' )
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
@@ -4694,5 +4903,7 @@
                                              logc_w_r, logc_ratio_w_r,         &
                                              logc_kbounds_w_r,                 &
-                                             nzt_topo_nestbc_r, 'r', 's' ) 
+                                             nzt_topo_nestbc_r,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'r', 's' ) 
      
                    CALL pmci_interp_tril_lr( nc, ncc, ico, jco, kco, r1xo,     &
@@ -4700,6 +4911,7 @@
                                              logc_w_r, logc_ratio_w_r,         &
                                              logc_kbounds_w_r,                 &
-                                             nzt_topo_nestbc_r, 'r', 's' )
-
+                                             nzt_topo_nestbc_r,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'r', 's' )
 
                 ENDIF
@@ -4712,5 +4924,8 @@
                                              logc_w_r, logc_ratio_w_r,         &
                                              logc_kbounds_w_r,                 &
-                                             nzt_topo_nestbc_r, 'r', 's' ) 
+                                             nzt_topo_nestbc_r,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s,              &
+                                             'r', 's' ) 
 
                    CALL pmci_interp_tril_lr( nr, nrc, ico, jco, kco, r1xo,     &
@@ -4718,5 +4933,7 @@
                                              logc_w_r, logc_ratio_w_r,         &
                                              logc_kbounds_w_r,                 &
-                                             nzt_topo_nestbc_r, 'r', 's' ) 
+                                             nzt_topo_nestbc_r,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'r', 's' ) 
 
                 ENDIF
@@ -4729,5 +4946,7 @@
                                           logc_w_r, logc_ratio_w_r,            &
                                           logc_kbounds_w_r,                    &
-                                          nzt_topo_nestbc_r, 'r', 's' )
+                                          nzt_topo_nestbc_r,                   &
+                                          kcto, iflo, ifuo, jflo, jfuo,        &
+                                          kflo, kfuo, ijkfc_s, 'r', 's' )
              ENDIF
 
@@ -4740,5 +4959,7 @@
                                              logc_w_r, logc_ratio_w_r,         &
                                              logc_kbounds_w_r,                 &
-                                             nzt_topo_nestbc_r, 'r', 's' )
+                                             nzt_topo_nestbc_r,                &
+                                             kcto, iflo, ifuo, jflo, jfuo,     &
+                                             kflo, kfuo, ijkfc_s, 'r', 's' )
                 ENDDO
              ENDIF
@@ -4751,28 +4972,36 @@
                                        r1yo, r2yo, r1zo, r2zo,                 &
                                        logc_u_s, logc_ratio_u_s,               &
-                                       logc_kbounds_u_s,                       &
-                                       nzt_topo_nestbc_s, 's', 'u' )
+                                       logc_kbounds_u_s, nzt_topo_nestbc_s,    &
+                                       kcto, iflu, ifuu, jflo, jfuo, kflo,     &
+                                       kfuo, ijkfc_u, 's', 'u' )
 
              CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
                                        r1yv, r2yv, r1zo, r2zo,                 &
                                        logc_v_s, logc_ratio_v_s,               &
-                                       logc_kbounds_v_s,                       &
-                                       nzt_topo_nestbc_s, 's', 'v' )
+                                       logc_kbounds_v_s, nzt_topo_nestbc_s,    &
+                                       kcto, iflo, ifuo, jflv, jfuv, kflo,     &
+                                       kfuo, ijkfc_v, 's', 'v' )
 
              CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
                                        r1yo, r2yo, r1zw, r2zw,                 &
                                        logc_w_s, logc_ratio_w_s,               &
-                                       logc_kbounds_w_s,                       &
-                                       nzt_topo_nestbc_s, 's','w' )
+                                       logc_kbounds_w_s, nzt_topo_nestbc_s,    &
+                                       kctw, iflo, ifuo, jflo, jfuo, kflw,     &
+                                       kfuw, ijkfc_w, 's','w' )
 
              IF ( (        rans_mode_parent  .AND.         rans_mode )  .OR.   &
                   (  .NOT. rans_mode_parent  .AND.  .NOT.  rans_mode  .AND.    &
                      .NOT. constant_diffusion ) )  THEN
-                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
-                                          r1yo, r2yo, r1zo, r2zo,              &
-                                          logc_w_s, logc_ratio_w_s,            &
-                                          logc_kbounds_w_s,                    &
-                                          nzt_topo_nestbc_s, 's', 'e' )
-
+!                CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo,  &
+!                                          r1yo, r2yo, r1zo, r2zo,              &
+!                                          logc_w_s, logc_ratio_w_s,            &
+!                                          logc_kbounds_w_s, nzt_topo_nestbc_s, &
+!                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+!                                          kfuo, ijkfc_s, 's', 'e' )
+!
+!--             Interpolation of e is replaced by the Neumann condition. 
+                DO jbgp = -nbgp, -1
+                   e(nzb:nzt,jbgp,nxl:nxr) = e(nzb:nzt,0,nxl:nxr)
+                ENDDO
              ENDIF
 
@@ -4781,7 +5010,7 @@
                                           r2xo, r1yo, r2yo, r1zo, r2zo,        &
                                           logc_w_s, logc_ratio_w_s,            &
-                                          logc_kbounds_w_s,                    &
-                                          nzt_topo_nestbc_s, 's', 's' )
-
+                                          logc_kbounds_w_s, nzt_topo_nestbc_s, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 's', 's' )
              ENDIF
 
@@ -4790,6 +5019,7 @@
                                           r1yo, r2yo, r1zo, r2zo,              &
                                           logc_w_s, logc_ratio_w_s,            &
-                                          logc_kbounds_w_s,                    &
-                                          nzt_topo_nestbc_s, 's', 's' )
+                                          logc_kbounds_w_s, nzt_topo_nestbc_s, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 's', 's' )
              ENDIF
 
@@ -4798,6 +5028,7 @@
                                           r1yo,r2yo, r1zo, r2zo,               &
                                           logc_w_s, logc_ratio_w_s,            &
-                                          logc_kbounds_w_s,                    &
-                                          nzt_topo_nestbc_s, 's', 's' )
+                                          logc_kbounds_w_s, nzt_topo_nestbc_s, &
+                                          kcto, iflo, ifuo, jflo, jfuo, kflo,  &
+                                          kfuo, ijkfc_s, 's', 's' )
 
                 IF ( bulk_cloud_model  .AND.  microphysics_morrison )  THEN
